/*
 * Decompiled with CFR 0.152.
 */
package fire.pb;

import java.lang.reflect.Method;
import java.util.List;
import java.util.Map;

public class XdbSelect {
    private boolean success;

    public String select(String tableKeyAndKeytype, String vars) {
        String keyAndType = tableKeyAndKeytype;
        String key = tableKeyAndKeytype;
        Class keyType = Long.class;
        if (keyAndType.endsWith("i")) {
            keyType = Integer.class;
        } else if (keyAndType.endsWith("s")) {
            keyType = String.class;
        }
        if (!keyType.getName().equals(Long.class.getName()) || keyAndType.endsWith("l")) {
            key = keyAndType.substring(0, keyAndType.length() - 1);
        }
        String[] cols = vars.split("\\.");
        String tableName = this.firstCharToUpperCase(cols[0]);
        String tablePackage = "xtable." + tableName;
        Class<?> tableClass = null;
        try {
            tableClass = Class.forName(tablePackage);
        }
        catch (Exception e) {
            return this.error("不存在的表:" + tableName);
        }
        catch (Error e) {
            return this.error("不存在的表:" + tableName);
        }
        Method selectMethod = null;
        try {
            selectMethod = tableClass.getMethod("select", keyType);
        }
        catch (Exception e) {
            return this.error("不存在的方法:select(" + keyType.getName() + ")");
        }
        catch (Error e) {
            return this.error("不存在的方法:select(" + keyType.getName() + ")");
        }
        Object tableResult = null;
        try {
            tableResult = keyType.getName().equals(Long.class.getName()) ? selectMethod.invoke(null, Long.valueOf(key)) : (keyType.getName().equals(Integer.class.getName()) ? selectMethod.invoke(null, Integer.valueOf(key)) : selectMethod.invoke(null, key));
        }
        catch (Exception e) {
            return this.error("请告知程序需要添加新的类型处理:" + keyType.getName());
        }
        catch (Error e) {
            return this.error("请告知程序需要添加新的类型处理:" + keyType.getName());
        }
        Class<?> tableValueType = tableResult.getClass();
        if (this.isBaseType(tableValueType)) {
            return this.success(tableName + " = " + tableResult.toString());
        }
        Class<?> varType = tableValueType;
        Object varResult = tableResult;
        String varName = tableName;
        for (int i = 1; i < cols.length; ++i) {
            if (this.isMap(varType)) {
                if ("mapkeys".equals(cols[i])) {
                    return this.success("mapkeys = " + ((Map)varResult).keySet().toString());
                }
                int mapKey = 0;
                try {
                    mapKey = Integer.valueOf(cols[i]);
                }
                catch (Exception e) {
                    return this.error("需要int型的mapKey");
                }
                varResult = ((Map)varResult).get(mapKey);
                if (null == varResult) {
                    return this.error("不存在的mapKey=" + mapKey);
                }
                varType = varResult.getClass();
                varName = varName + ".get(" + mapKey + ")";
                continue;
            }
            if (this.isList(varType)) {
                if ("size".equals(cols[i])) {
                    return this.success("size = " + String.valueOf(((List)varResult).size()));
                }
                int index = 0;
                try {
                    index = Integer.valueOf(cols[i]);
                }
                catch (Exception e) {
                    return this.error("需要int型的listIndex");
                }
                varResult = ((List)varResult).get(index);
                if (null == varResult) {
                    return this.error("不存在的listIndex=" + index);
                }
                varType = varResult.getClass();
                varName = varName + ".get(" + index + ")";
                continue;
            }
            varName = this.firstCharToUpperCase(cols[i]);
            String varGetMethodName = "get" + varName;
            Method varGetMethod = null;
            try {
                varGetMethod = varType.getMethod(varGetMethodName, new Class[0]);
            }
            catch (Exception e) {
                return this.error(varType.getName() + "中不存在的方法:" + varGetMethodName);
            }
            catch (Error e) {
                return this.error(varType.getName() + "中不存在的方法:" + varGetMethodName);
            }
            try {
                varResult = varGetMethod.invoke(varResult, new Object[0]);
            }
            catch (Exception e) {
                return this.error(e.getMessage());
            }
            varType = varResult.getClass();
            if (!this.isBaseType(varType)) continue;
            return this.success(varName + " = " + varResult.toString());
        }
        return this.success(varName + " = " + varResult.toString());
    }

    private String success(String result) {
        this.success = true;
        return result;
    }

    private String error(String result) {
        this.success = false;
        return result;
    }

    private String firstCharToUpperCase(String s) {
        return s.replaceFirst(String.valueOf(s.charAt(0)), String.valueOf(s.charAt(0)).toUpperCase());
    }

    private boolean isBaseType(Class<?> clazz) {
        return !this.isXbean(clazz) && !this.isMap(clazz) && !this.isList(clazz);
    }

    private boolean isXbean(Class<?> clazz) {
        return clazz.getName().startsWith("xbean");
    }

    private boolean isMap(Class<?> clazz) {
        return clazz.getName().startsWith("java") && clazz.getName().indexOf("Map") > 0;
    }

    private boolean isList(Class<?> clazz) {
        return clazz.getName().startsWith("java") && clazz.getName().indexOf("List") > 0;
    }

    public boolean isSuccess() {
        return this.success;
    }
}

